<script lang="ts" setup>
/** Used for sticky content or can be updated to also handle a navigation */

import type { BaseLink, BaseIcon } from '@/types/base';
import { ArrowDown } from 'slippers-ui/icons';

const icons = {
  ArrowDown,
};

interface StickyBarProps {
  text: string;
  cta?: BaseLink;
  icon?: BaseIcon;
}

defineProps<StickyBarProps>();

const sticky = ref(false);
const navbar = ref<InstanceType<typeof HTMLElement> | null>(null);

const handleScroll = () => {
  const stickyOffset = navbar.value.offsetTop;
  const nextStepsElement = document.querySelector('.next-steps');
  const footerElement = document.querySelector('footer');

  const scrollPosition = window.scrollY;

  const nextStepsPosition = nextStepsElement?.offsetTop ?? Infinity;
  const footerPosition = footerElement?.offsetTop ?? Infinity;

  const stopPosition = Math.min(nextStepsPosition, footerPosition);

  sticky.value = scrollPosition > stickyOffset - 84 && scrollPosition < stopPosition - 150;
};
onMounted(() => {
  window.addEventListener('scroll', handleScroll);
});

onUnmounted(() => {
  window.removeEventListener('scroll', handleScroll);
});
</script>

<template>
  <div>
    <div ref="navbar" class="sticky-nav" :class="{ sticky: sticky }">
      <SlpContainer>
        <div class="content">
          <div class="text">
            {{ text }}
          </div>
          <SlpButton
            v-if="cta"
            class="link"
            variant="tertiary"
            :href="cta.config.href"
            :data-ga-name="cta.config.dataGaName"
            :data-ga-location="cta.config.dataGaLocation"
          >
            {{ cta.text }}
            <SlpIcon v-if="icon" :icon="icons[icon.config.name]" color="text-50" size="sm" />
          </SlpButton>
        </div>
      </SlpContainer>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.sticky-nav {
  padding: $spacing-16 0;
  transition: all 0.3s ease;
  z-index: 100;
  background-color: $color-surface-700;
  color: $color-text-50;
  font-size: 18px;
  line-height: 20px;

  &.sticky {
    position: fixed;
    top: 84px;
    width: 100%;
    @media (max-width: $breakpoint-sm) {
      top: 116px;
    }
  }
}

.content {
  display: flex;
  align-items: center;
  justify-content: center;

  .text {
    font-weight: $font-weight-bold;
  }

  .link {
    margin-left: $spacing-64;
    color: $color-text-50;
    text-decoration: underline;
    padding: 0;
    font-size: 18px;

    @media (max-width: $breakpoint-md) {
      margin-left: $spacing-8;

      .slp-icon {
        display: none;
      }
    }
  }
}
</style>
